{
AW>Also, I created a file of strings that was 10 times as large as
AW>the  original ASCII file. Is there anyway to shrink this file
AW>without  changing the data type too much? (I need to Use Seek.)

You could try something like this:
}

var
  seekablefile : file of byte;
  seekindex : array[word] of longint;
  {etc.}
{initialize, etc.}
linenumber := 0;
fillchar(seekindex,sizeof(seekindex),0);
while not eof(atextfile) do begin
  readln(atextfile,astring);
  inc(linenumber);
  seekindex[linenumber] := seekindex(pred(linenumber))
    + length(astring) + 1;
  blockwrite(seekablefile,astring,length(astring) + 1);
  end;

{to use:}
seek(seekablefile,seekindex[linenumber]);
blockread(seekablefile,astring,sizeof(astring));

{
The size of seekablefile is the size of atextfile minus the maximum
linenumber.

Instead of this, you can use the ttextstream type from Duncan
Murdock's  streams. Another option is Wilbert Van Leijen's
TEXTUNIT.PAS available  in the SWAG.

Pierre Tourigny
---------------
  <  94-06-27 :   pierre.tourigny@synapse.org
  >= 94-06-27 :   pierre.tourigny@synapse.net


 * Synapse BBS - Gatineau, QUE - (819) 561-4321
}
