{
 MD> I'm using TP5.5 (ancient). The manual says that one cannot
 MD> read or write enumerated variables.

 MD> How can one display them? The method in the book doesn't
 MD> work on sets. What I'm trying do write is a program that
 MD> will accept the hobbies of two people (set of hobbies),
 MD> then intersect the two sets and display this set.

 MD> I have found that sets and enumerated variables don't work
 MD> well together. Is is possible to equate from strings to
 MD> enumerated var and back again? How?

I think they work pretty well together, but Pascal is not good at displaying
them.  You need to keep the names in an array yourself, and loop through all
possibilities to display them:
}

 type
   THobby = (programming, stampcollecting);
   THobbies = set of THobby;
 const
   HobbyNames : array[THobby] of string[20] =
     ('Programming', 'Stamp Collecting');
 var
   myhobbies, yourhobbies, ourhobbies : THobbies;
   hobby : THobby;
 begin
   myhobbies := ...
   yourhobbies := ...
   ourhobbies := myhobbies*yourhobbies;
   write('We both do ');
   for  hobby := programming to stampcollecting do
    if hobby in ourhobbies then
      write(Hobbynames[hobby],' ');
 end.

{
I hope this helps.


--- 
 * Origin: Murdoch's Point, Kingston, Ont, Canada  - -   (1:249/1.5)
}
