{
SD>Bericht : Array [1..100] of String[80];
SD>Message : Array [1..8000] of Char;

SD>Each line in 'Bericht' ends with an Omega (ALT - 234) so I can know what the
SD>end of a line is.

SD>How do I convert whatever is in Bericht to Message ? And once I did that, how
SD>do I convert Message back to an Array of String ???

Assuming you plan to carry the #234 character into the array of
char and that you have preserved the length byte of each string:
}

FillChar(Message,Sizeof(Message),0);
C := 0;
For A := 1 to 100 Do
  For B := 1 to Length(Bericht[A]) Do
    Begin
    Inc(C);
    Message[C] := Bericht[A][B];
    End;

{
And then to go back:
}

FillChar(Bericht,Sizeof(Bericht),0);
A := 1;
C := 0;
  Repeat
  Inc(C);
  If Message[C] = #234 Then
    Inc(A)
  Else
    Bericht[A] := Bericht[A] + Message[C];
  Until (C = 8000) or (WhatDeterminesEndofMessage);

{
Note that these are very basic with no error checking, but should
give you a start.


--- 
 * Origin: Chandler Programmer's Connection: AZ (602)-759-7789 (1:114/268)
}
